note
	description: "[
			Used with EDITOR classes to make EV_WIDGETs for displaying and
			editting data which is a DATE
			]"
	instructions: "[
			]" 
	author: "Jimmy J. Johnson"
	date: "7 Mar 03"

class
	YMD_TIME_CONTROL

inherit
	
	YMD_CONSTANTS
		undefine
			default_create,
			is_equal,
			copy
		end
	
	SPIN_CONTROL
		redefine
			initialize,
			value,
			increment,
			decrement
		end
		
create
	default_create,
	make_from_field

feature {NONE} -- Initialization

	initialize
			-- Set up the control
		do
			Precursor {SPIN_CONTROL}
			set_delta (One_day)
		end
		

feature -- Access

	value: YMD_TIME
			-- A new object represented by the string in the display.
			-- Redefine to convert the displayed string into the 
			-- desired type.
		do
			Result ?= Precursor {SPIN_CONTROL}
		end

	delta: YMD_DURATION
			-- The amount to change `value' when one of the buttons is pressed.

feature -- Element change

	set_delta (a_delta: like delta)
			-- Change `delta'
		require
			positive_delta: not a_delta.is_negative
		do
			delta := a_delta.twin
		ensure
			delta_assigned: equal (delta, a_delta)
		end
		
feature -- Basic operations

	increment
			-- Increase the `value' by amount `step'.
		do
			Precursor {SPIN_CONTROL}
			set_data (value + delta)
			on_display_changed
		end
		
	decrement
			-- Decrease the `value' by amount `step'.
		do
			Precursor {SPIN_CONTROL}
			set_data (value - delta)
			on_display_changed
		end

feature {NONE} -- Implementation

	default_field: YMD_TIME_FIELD
			-- Dictates appearanced of current Control
		do
			create Result
		end
		
end -- class YMD_TIME_CONTROL
