note
	description: "[
				A FIELD used to create a INTEGER_CONTROL and position that control.
				]"
	author: "Jimmy J. Johnson"
	date: "24 Feb 04"

class
	INTEGER_FIELD

inherit

	COMPARABLE_FIELD
		redefine
			default_create,
			type,
			is_valid_data,
			string_to_type
		end

create
	default_create

feature {NONE} -- Initialization

	default_create
			-- Create an instance
		do
			Precursor {COMPARABLE_FIELD}
		end

feature -- Querry

	Type: INTEGER_REF
			-- Implementation (and anchor) of `value'.
			-- Redefined to change type.
		once
			create Result
		end

	string_to_type (a_string: STRING_32): like type
			-- Convert `a_string' to an object of `Type'.
		do
			create Result
			Result.set_item (a_string.to_integer)
		end

	is_valid_data (a_value: ANY): BOOLEAN
			-- Is the value in the display a valid representation
			-- for the type of the data.
		local
			s: STRING_32
		do
			Result := Precursor {COMPARABLE_FIELD} (a_value)
			if not Result then
					-- It may be that `a_value' is a STRING representation
					-- of an integer, so check the string and convert it.
				s ?= a_value
				Result := s /= Void and then s.is_integer
			end
		end

feature -- Transformation

	as_widget: INTEGER_CONTROL
			-- Create the appropriate type of control
		do
			create Result.make_from_field (Current)
		end

end -- class INTEGER_FIELD
