note
	description: "[
		Expands DATASTORE_FACILITIES by adding DATASTOREs useful in 
		the "Standard Interface" cluster.
		]"
	author: "Jimmy J. Johnson"
	date: "29 Jan 05"

class
	JJ_VISION_DATASTORE_FACILITIES

inherit

	JJ_VISION_FILE_FACILITIES

	DATASTORE_FACILITIES

feature -- Access

	icon_datastore: DATASTORE
			-- Used for storing the images (icons, cursors, etc) in a system.
			-- The default is a STORABLE_DATASTORE with `location' set to the
			-- "default image directory" under the "default program directory".
		local
			sd: DATASTORE
		once
			create sd.make (merged_file_name (Default_program_directory_name, Default_icon_directory_name))
			Result := sd
		ensure
			result_exists: Result /= Void
			location_set: equal (Result.name, merged_file_name (Default_program_directory_name, Default_icon_directory_name))
		end

feature {NONE} -- Implementation (constants)

	Default_icon_directory_name: STRING = "icons"
			-- The path name of directory where the system thinks its executable is located.

end
