note
	description: "[
				Windows for setting states for MAIN_WINDOW.
				]"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	PREFERENCES_WINDOW

inherit

	VIEW
		undefine
--			default_create,
			copy
		redefine
			initialize,
			destroy,
			is_destroyed
		end

	EV_TITLED_WINDOW
		rename
			object_id as ise_object_id
		redefine
			initialize,
			is_in_default_state,
			destroy,
			is_destroyed
		end

create
	default_create

feature {NONE} -- Initialization

	initialize
			-- Set up the window
		do
			Precursor {EV_TITLED_WINDOW}
			Precursor {VIEW}
			create view_manager
			set_title ("System Preferences")
--			view_manager.register_view_function (agent get_window_preferences_page)
--			view_manager.create_view (1)
			view_manager.extend_view (create {WINDOW_PREFERENCES_VIEW})
			extend (view_manager.cell)
		end

	is_in_default_state: BOOLEAN
			-- Is the window in its default state?
			-- Redefined to ignore this check.
			-- Left as routine so it can be redefined.
		do
			Result := True
		end

feature -- Access

	view_manager: VIEW_MANAGER
			-- Give window ability to switch between views

feature -- Basic operations

	destroy
			-- Destroy underlying native toolkit object.
			-- Render `Current' unusable.
		do
			Precursor {VIEW}
			Precursor {EV_TITLED_WINDOW}
		end

feature -- Status report

	is_destroyed: BOOLEAN
			-- Is `Current' no longer usable?
		do
			Result := Precursor {VIEW} and Precursor {EV_TITLED_WINDOW}
		end

feature {NONE} -- Implementation

--	get_window_preferences_page: WINDOW_PREFERENCES_VIEW
--			-- Used as agent for creating one of the views managed by `view_manager'.
--		do
--			create Result
--		end

end
