note
	description: "Tool for editing text."
	author: "Brooke Johnson"
	date: "4 Jan 08"

class
	TEXT_TOOL

inherit

	TOOL
		redefine
			initialize,
			initialize_interface,
			build_tool_bars,
			set_actions
--			view
		end

create
	default_create

feature {NONE} -- Initialization

	initialize
			-- Build the interface for this window
		do
			create clear_button
			Precursor {TOOL}
			create view
			split_manager.extend (view)
		end

	initialize_interface
			-- Create INTERFACE_ITEMs which could be used by Current.
			-- Called by `initialize'.
		do
			if not interface_table.has_key (generating_type) then
				interface_table.add_item_with_tuple (<< generating_type, "TEXT_TOOL", "This represents A TEXT_TOOL.", "This object represents a TEXT_TOOL.", "icon_bkpt_info_color.ico">>)
			end
			interface_table.add_item_with_tuple (<<"{TEXT_TOOL}.clear_button", "Clear", "Clear the view.", "Clear the view.", "icon_recycle_bin_color.ico">>)
			Precursor {TOOL}
		end

	build_tool_bars
			-- Create the two toolbars.
		do
			Precursor {TOOL}
				-- Put pixmaps, tool-tips, etc on buttons
			interface_table.register_widget (clear_button, "{TEXT_TOOL}.clear_button")
				-- Place buttons in toolbar
			tool_bar.extend (clear_button)
			tool_bar.extend (create {EV_TOOL_BAR_SEPARATOR})
		end

	set_actions
			-- Adds agents to the buttons and menues.
		do
			Precursor {TOOL}
			clear_button.pointer_button_press_actions.force_extend (agent clear)
		end

feature {NONE} -- Implementation

	clear
			-- delete all text
		do
			view.remove_text
		end

	clear_button: EV_TOOL_BAR_BUTTON
			-- Button to move to previous record

	view: TEXT_VIEW
			-- Text area for displaying ships info, etc.

end
