note
	description: "[
				Used by VIEW_MANAGER as a place holder when it has
				no views.
				]"
	author: "Jimmy J. Johnson"
	date: "29 Aug 03"

class
	DEFAULT_VIEW

inherit

	VIEW
		undefine
			copy
		redefine
			initialize,
			destroy,
			is_destroyed
		end

	EV_LABEL
		rename
			object_id as ise_object_id
		redefine
			initialize,
			is_in_default_state,
			destroy,
			is_destroyed
		end


create
	default_create

feature {NONE} -- Initialization

	initialize
			-- Set up the view
		do
			Precursor {VIEW}
			Precursor {EV_LABEL}
			set_text ("Default view")
		end

feature -- Status report

	is_in_default_state: BOOLEAN = True
			-- Redefined to ignore this check

feature -- Basic operations

	destroy
			-- Destroy underlying native toolkit object.
			-- Render `Current' unusable.
		do
			Precursor {VIEW}
			Precursor {EV_LABEL}
		end

feature -- Status report

	is_destroyed: BOOLEAN
			-- Is `Current' no longer usable?
		do
			Result := Precursor {VIEW} and Precursor {EV_LABEL}
		end

end -- class DEFAULT_VIEW
