note
	description: "[
				An special DIALOG_EDITOR_VIEW used to edit a FIELD.  
				
				A FIELD_SCHEMA can not be created when a FIELD is created, because, as Manu
				from ISE described, both FIELD and SCHEMA would relie on the creation of the
				other and an object would be referenced	before the created object was ever
				assigned to the `Result' in `default_create'.
		]"
	author: "Jimmy J. Johnson"
	date: "27 Feb 04"

class
	FIELD_EDITOR_VIEW

inherit

	DIALOG_EDITOR_VIEW
		rename
			record as field,
			set_record as set_field
		redefine
			field,
			set_field,
			new_edit_command
		end

create
	default_create

feature -- Access

	field: FIELD
			-- Contains the data to be editted.

feature -- Element change

	set_field (a_field: like field)
			-- Change the `field'.
		do
				-- Redefined to ensure the `schema' for `a_field' is set.
				-- It may alread be here, but not always.
				-- Note that `draw' is called by Precursor.
			set_schema (a_field.schema)
			Precursor {DIALOG_EDITOR_VIEW} (a_field)
		end

feature {NONE} -- Implementation (actions)

	parent_schema: SCHEMA
			-- The schema being editted by the `parent_tool' which
			-- must be a EDIT_TOOL.
		local
			pt: EDIT_TOOL
		do
			pt ?= parent_tool
			check
				parent_exists: pt /= Void
					-- Because the parent of current must be an EDIT_TOOL
			end
			Result := pt.get_schema
		end

	new_edit_command: EDIT_SCHEMA_COMMAND
			-- Used by `save_record' to get the correct type of command.
			-- It is special for this type as it is a field that is
			-- changing but the command affects a SCHEMA.
		do
			create Result
			Result.set_record (field)
			Result.set_schema (parent_schema)
		end


end
