note
	description: "[
		Common ancestor to classes used to persist the state of the 
		views.
		]"
	author: "Jimmy J. Johnson"
	date: "15 Mar 08"

deferred class
	STATE

--inherit
--	ID_FACILITIES


feature {NONE} -- Initialization

	make (a_object: ANY)
			-- Create a structure to save the state of an object.
			-- This is really for persisting the state of EV_WIDGETs or objects
			-- that reference EV_WIDGETs, because EV_WIDGETs have no persistent
			-- image.
		require
			object_exists: a_object /= Void
		do
		end

feature -- Access

	widget: ANY
			-- The object initialized with the attributes of Current.
			-- Redefine to add new attriutes after calling Precursor.
		do
			Result := new_widget
		ensure
			result_exists: Result /= Void
		end

feature {NONE} -- Implementation

	application: JJ_APPLICATION
			-- Handle to the current application
		local
			app: JJ_APPLICATION
		once
			Result ?= (create {EV_ENVIRONMENT}).application
		ensure
			result_exists: Result /= Void
		end

	new_widget: like widget
			-- This is called by `widget'; the result of `widget' is created here and
			-- used in the redefined versions.
		do
			create Result
		end

end
