note
	description: "[
			Used to store the appearance of VIEWs.
		]"
	author: "Jimmy J. Johnson"
	date: "13 Oct 04"

class
	TOOL_STATE

inherit

	VIEW_STATE
		redefine
			default_create,
			make,
			widget
		end

create
	default_create,
	make

feature {NONE} -- Initialization

	default_create
			-- Initialize the instance using reasonable values
		do
			Precursor {VIEW_STATE}
		end

	make (a_tool: TOOL)
			-- Initialize `Current'.
		do
			Precursor {VIEW_STATE} (a_tool)
			is_maximized := a_tool.is_maximized
			is_resizable := a_tool.is_resizable
		end

feature -- Access

	widget: TOOL
			-- Create a TOOL from the attributes of Current
		do
			Result ?= Precursor {VIEW_STATE}
			check
				result_exists: Result /= Void
					-- Because Precursor calls `new_widget' defined as "like `widget'".
			end
			if is_maximized then
				Result.maximize
			else
				Result.restore
			end
			if is_resizable then
				Result.enable_resize
			else
				Result.disable_resize
			end
		end

feature {NONE} -- Implementation

	is_maximized: BOOLEAN
			-- Holds the value of a tools `is_maximized' feature.

	is_resizable: BOOLEAN
			-- Holds the value of a tools `is_resizable' feature.

end
