note
	description: "[
			Used to store the appearance of VIEWs.
			This class and descendants are used to capture some attributes of EV_WIDGETs
			so that the [appearance of] the widgets can be persisted.
		]"
	author: "Jimmy J. Johnson"
	date: "13 Oct 04"

class
	VIEW_STATE

inherit

	STATE
		redefine
			default_create,
			make,
			widget
		end

create
	default_create,
	make

feature {NONE} -- Initialization

	default_create
			-- Initialize the instance using reasonable values
		do
--			create target_id_set.make
--			target_id_set.compare_objects
		end

	make (a_view: VIEW)
			-- Initialize `Current'.
		local
			lin: LINEAR [ANY]
			a: ANY
--			ds: DATASTORE
		do
--			ds := Application.persistence_manager.user_datastore
--			a := a_view.target
--			if a /= Void and then ds.is_stored (a) then
--				target_id := Application.persistence_manager.user_datastore.object_id (a)
--			else
--				target_id := Void_id
--			end
--			create target_id_set.make
--			lin := a_view.objects
--			from lin.start
--			until lin.exhausted
--			loop
--				a := lin.item
--				if a /= Void and then ds.is_stored (a)then
--					target_id_set.extend (Application.persistence_manager.user_datastore.object_id (a))
--				end
--				lin.forth
--			end
--			split_manager_state := a_view.split_manager.state
		end

feature -- Access

	widget: VIEW
			-- A VIEW created from the attributes of Current.
		local
			t: like target_anchor
--			ident: OBJECT_ID
		do
			Result ?= Precursor {STATE}
--			check
--				result_exists: Result /= Void
--					-- Because Precursor calls `new_widget' defined as "like `widget'".
--			end
--			if target_id /= Void_id then
----				t ?= Application.persistence_manager.user_datastore.loaded (target_id)
--				if t /= Void then
--					Result.set_target (t)
--				end
--			end
--		 	from target_id_set.start
--		 	until target_id_set.exhausted
--		 	loop
--		 		ident := target_id_set.item
----		 		t ?= Application.persistence_manager.user_datastore.loaded (ident)
--		 		if t /= Void then
--			 		Result.add_target (t)
--		 		end
--		 		target_id_set.forth
--		 	end
--		 	Result.set_split_manager (split_manager_state.widget)
		end

feature {NONE} -- Access

--	target_id: OBJECT_ID
			-- Holds the id of the view's `target'.

--	target_id_set: LINKED_SET [like target_id]
			-- Holds the ids of the view's `objects'.

	split_manager_state: SPLIT_MANAGER_STATE
			-- Holds the state of the `split_manager'.

feature {NONE} -- Implementation

	target_anchor: ANY
			-- Type anchor for the creation of a new target of the correct type
			-- and to check that retrieval of an object from a DATASTORE is of
			-- the correct type.
			-- Declared as once to prevent adding an attribute to Current
			-- Redefine covariantly descendents of VIEW to correspond to the type
			-- of the `target' from the redefined VIEW.

		once
		ensure
			not_used: Result = Void
		end

end
